if _G.IS_VR then
	return
end

local hooked_class
local required_script = string.lower(RequiredScript)
if required_script == "lib/units/beings/player/states/playercarry" then
	hooked_class = nil
	
	local orig_check_use_item = Hooks:GetFunction(PlayerCarry,"_check_use_item")
	Hooks:OverrideFunction(PlayerCarry,"_check_use_item",function(self,t,input,...)
		local new_action
		local action_wanted = MoreSeparateKeybinds:KeyHeld("keybind_altk_throwbag")
		
		if action_wanted then
			local action_forbidden = self._use_item_expire_t or self:_changing_weapon() or self:_interacting() or self._ext_movement:has_carry_restriction() or self:_is_throwing_projectile() or self:_on_zipline()

			if not action_forbidden then
				managers.player:drop_carry()

				new_action = true
			end
			
			self._throw_down = false
			self._second_press = false

			return PlayerCarry.super._check_use_item(self, t, input)
		end
		
		local suppress_original_input = MoreSeparateKeybinds.settings.useitem_suppress_input
		if not (suppress_original_input or new_action) then 
			new_action = orig_check_use_item(self,t,input,...)
		end
		
		return new_action
	end)
	
elseif required_script == "lib/units/beings/player/states/playercivilian" then
	hooked_class = PlayerCivilian
elseif required_script == "lib/units/beings/player/states/playermaskoff" then
	hooked_class = PlayerMaskOff
elseif required_script == "lib/units/beings/player/states/playerstandard" then
	hooked_class = PlayerStandard
	
	Hooks:PreHook(PlayerStandard,"update","altk_update_input",function(self,t,dt)
		MoreSeparateKeybinds:UpdateInput(t,dt)
	end)
	
	local orig_check_use_item = Hooks:GetFunction(PlayerStandard,"_check_use_item")
	Hooks:OverrideFunction(PlayerStandard,"_check_use_item",function(self,t,input,...)
		local new_action
		local settings = MoreSeparateKeybinds.settings
		local useitem_down = MoreSeparateKeybinds:KeyDown("keybind_altk_placedeployable")
		local interrupt_down = MoreSeparateKeybinds:KeyDown("keybind_altk_interruptuse")
		local useitem_released = MoreSeparateKeybinds:KeyReleased("keybind_altk_placedeployable")
		local toggle_useitem = settings.useitem_toggle_enabled
		
		local action_wanted = useitem_down
		
		if (not toggle_useitem and useitem_released) or (toggle_useitem and interrupt_down) then
			self:_interupt_action_use_item()
		elseif action_wanted then
			local action_forbidden = self._use_item_expire_t or self:_interacting() or self:_changing_weapon() or self:_is_throwing_projectile() or self:_is_meleeing()
			
			if not action_forbidden and managers.player:can_use_selected_equipment(self._unit) then
				self:_start_action_use_item(t)
				new_action = true
			end
		end
		
		if toggle_useitem then 
			input.btn_use_item_release = nil
		end
		
		local suppress_original_input = settings.useitem_suppress_input
		if not new_action and not suppress_original_input then 
			new_action = orig_check_use_item(self,t,input,...)
		end
		return new_action
	end)
	
	local orig_check_action_weapon_firemode = Hooks:GetFunction(PlayerStandard,"_check_action_weapon_firemode")
	Hooks:OverrideFunction(PlayerStandard,"_check_action_weapon_firemode",function(self,t,input,...)
		local default_pressed = input.btn_weapon_firemode_press 
		local firemode_pressed = MoreSeparateKeybinds:KeyPressed("keybind_altk_firemode")
		
		if firemode_pressed then 
			local action_forbidden = self:is_shooting_count()
			if not action_forbidden then 
				local base_ext = self._equipped_unit:base()
				if base_ext.toggle_firemode then
					self:_check_stop_shooting()

					if base_ext:toggle_firemode() then

						managers.hud:set_teammate_weapon_firemode(HUDManager.PLAYER_PANEL, self._unit:inventory():equipped_selection(), base_ext:fire_mode(), base_ext:alt_fire_active())
						return
					end
				end
			end
		end
		
		local suppress_original_input = MoreSeparateKeybinds.settings.firemode_suppress_input
		if not suppress_original_input then 
			return orig_check_action_weapon_firemode(self,t,input,...)
		end
	end)
	
	local orig_check_action_weapon_gadget = Hooks:GetFunction(PlayerStandard,"_check_action_weapon_gadget")
	Hooks:OverrideFunction(PlayerStandard,"_check_action_weapon_gadget",function(self,t,input,...)
	--	local default_pressed = input.btn_weapon_gadget_press
		
		local laser_pressed = MoreSeparateKeybinds:KeyPressed("keybind_altk_laser")
		local flash_pressed = MoreSeparateKeybinds:KeyPressed("keybind_altk_flash")
		local optic_pressed = MoreSeparateKeybinds:KeyPressed("keybind_altk_optic")
	
		local weapon_unit = self._equipped_unit
		local weapon_base = weapon_unit and weapon_unit:base()

		if laser_pressed then 
			MoreSeparateKeybinds:ToggleGadget(self,weapon_base,"laser",false)
		end
		if flash_pressed then 
			MoreSeparateKeybinds:ToggleGadget(self,weapon_base,"flashlight",false)
		end
		if optic_pressed then 
	--		MoreSeparateKeybinds:ToggleGadget(self,weapon_base,"second_sight",false)
			weapon_base:toggle_second_sight(self)
		end
		
		local suppress_original_input = MoreSeparateKeybinds.settings.gadget_suppress_input
		if not suppress_original_input then 
			return orig_check_action_weapon_gadget(self,t,input,...)
		end
	end)
	
	local orig_check_action_night_vision = Hooks:GetFunction(PlayerStandard,"_check_action_night_vision")
	Hooks:OverrideFunction(PlayerStandard,"_check_action_night_vision",function(self,t,input,...)
		local nvg_pressed = MoreSeparateKeybinds:KeyPressed("keybind_altk_nvg")
		if nvg_pressed then 
			self:set_night_vision_state(not self._state_data.night_vision_active)
		end
		
		local suppress_original_input = MoreSeparateKeybinds.settings.firemode_suppress_input
		if not suppress_original_input then 
			return orig_check_action_night_vision(self,t,input,...)
		end
	end)
end

if not hooked_class then 
	return
end

local orig_check_action_interact = Hooks:GetFunction(hooked_class,"_check_action_interact")
Hooks:OverrideFunction(hooked_class,"_check_action_interact",function(self,t,input,...)
	local keyboard = self._controller.TYPE == "pc" or managers.controller:get_default_wrapper_type() == "pc"
	local settings = MoreSeparateKeybinds.settings
	local default_pressed = input.btn_interact_press
	local default_released = input.btn_interact_release
	
	local interrupt_down = MoreSeparateKeybinds:KeyDown("keybind_altk_interruptuse")
	
	local interact_down = MoreSeparateKeybinds:KeyDown("keybind_altk_interact")
	local interact_released = MoreSeparateKeybinds:KeyReleased("keybind_altk_interact")
	local intimidate_down = MoreSeparateKeybinds:KeyDown("keybind_altk_intimidate")
	local call_down = MoreSeparateKeybinds:KeyDown("keybind_altk_call")
	local mark_down = MoreSeparateKeybinds:KeyDown("keybind_altk_mark")
	local toggle_interact = settings.interact_toggle_enabled
	
	local new_action
	
	if (not toggle_interact and interact_released) or (toggle_interact and interrupt_down) then 
		self:_interupt_action_interact()
	elseif interact_down then 
		-- If modifier is enabled and key combination is pressed,
		-- or if custom key is pressed
		if not settings.interact_use_modifier or default_pressed then
			new_action = new_action or MoreSeparateKeybinds:_DoActionInteract(self,t,input)
			--MoreSeparateKeybinds:c_log("Interact " .. tostring(new_action))
		end
	end
	if call_down then 
		if not settings.call_use_modifier or default_pressed then
			new_action = new_action or MoreSeparateKeybinds:_DoActionCall(self,t,input)
			--MoreSeparateKeybinds:c_log("Call " .. tostring(new_action))
		end
	end
	if intimidate_down then 
		if not settings.intimidate_use_modifier or default_pressed then
			new_action = new_action or MoreSeparateKeybinds:_DoActionIntimidate(self,t,input)
			--MoreSeparateKeybinds:c_log("Intimidate " .. tostring(new_action))
		end
	end
	if mark_down then 
		if not settings.mark_use_modifier or default_pressed then
			new_action = new_action or MoreSeparateKeybinds:_DoActionMark(self,t,input)
			--MoreSeparateKeybinds:c_log("Marked " .. tostring(new_action))
		end
	end
	
	local suppress_original_input = MoreSeparateKeybinds.settings.interact_suppress_input
	if not new_action and not suppress_original_input then
--	seven's press2hold compat; redundant
--		if self._check_interaction_input then 
--			self:_check_interaction_input(input)
--		end
		
		if toggle_interact then 
			input.btn_interact_release = nil
			
			-- manual default shout detection;
			-- removing the interact release from the input table breaks default shout otherwise
			local secondary_delay = tweak_data.team_ai.stop_action.delay
			local force_secondary_intimidate = false
			
			if not new_action then
				self._start_intimidate = true
				self._start_intimidate_t = t

				if keyboard and input.btn_interact_secondary_press then
					force_secondary_intimidate = true
				end
				
				if default_released then
					if self._start_intimidate and not self:_action_interact_forbidden() then
						if t < self._start_intimidate_t + secondary_delay then
							self:_start_action_intimidate(t)

							self._start_intimidate = false
						end
					else
						self:_interupt_action_interact()
					end
					
				end
			end
			if (self._start_intimidate or force_secondary_intimidate) and not self:_action_interact_forbidden() and (not keyboard and t > self._start_intimidate_t + secondary_delay or force_secondary_intimidate) then
				self:_start_action_intimidate(t, true)
				
				self._start_intimidate = false
			end
		end
		
		return orig_check_action_interact(self,t,input,...)
	end
	
	return new_action
end)
